/**
 * Copyright asou_jp ( http://wonderfl.net/user/asou_jp )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/a1Di
 */

package
{
    import flash.text.TextField;
    import a24.tween.EventTween24;
    import a24.tween.Tween24;
    import flash.display.Bitmap;
    import flash.display.BitmapData;
    import flash.display.Sprite;
    import flash.geom.Matrix;
    import flash.text.TextFieldAutoSize;
    import flash.text.TextFormat;

    [SWF(width = "465", height = "465", frameRate = "60", backgroundColor="#000000")]

    public class HellowTween24 extends Sprite {

        public function HellowTween24()
        {
            // Background
            var bg:Sprite = new Sprite();
            bg.graphics.beginFill(0);
            bg.graphics.drawRect(0, 0, 465, 465);
            addChild(bg);

            // MouseEvent Tween
            EventTween24.onRollOver(bg,
                Tween24.tween(bg, 0.05).bright(1),
                Tween24.tween(bg, 0.2).bright(0.4)
            );
            
            EventTween24.onRollOut(bg, 
                Tween24.tween(bg, 0.4).bright(0)
            );
            
            EventTween24.onClick(bg, 
                Tween24.getURL("http://code.google.com/p/tween24/", "_blank")
            );
            
            // Tween Animation
            var text1:Bitmap = getTextField(40, "more Easily");
            var text2:Bitmap = getTextField(40, "more Speedy");
            var text3:Bitmap = getTextField(40, "and more Powerful");
            var text4:Bitmap = getTextField(32, "New tween library Tween24 ");
            var text5:Bitmap = getTextField(16, "more comfortable your flash development.");

            Tween24.serial(
                Tween24.func(EventTween24.enabled, false, bg),
                Tween24.wait(0.5),
                // Text1 tween
                Tween24.prop(text1).$x(-460).fadeIn().glow(0xFFFFFF, 1, 32, 32, 6, 2).blurX(128),
                Tween24.addChild(this, text1),
                Tween24.tween(text1, 0.1).fadeIn(),
                Tween24.tween(text1, 0.1).$x(0),
                Tween24.prop(text1).glow(0xFFFFFF, 0.5, 12, 12, 2).blurX(0),
                Tween24.wait(1.5),
                Tween24.prop(text1).glow(0xFFFFFF, 1, 32, 32, 6, 2).blurX(128),
                Tween24.tween(text1, 0.1).$x(200).andRemove(),
                Tween24.wait(0.5),

                // Text3 tween
                Tween24.prop(text2).$x(-460).fadeIn().glow(0xFFFFFF, 1, 32, 32, 6, 2).blurX(128),
                Tween24.addChild(this, text2),
                Tween24.tween(text2, 0.1).fadeIn(),
                Tween24.tween(text2, 0.1).$x(0),
                Tween24.prop(text2).glow(0xFFFFFF, 0.5, 12, 12, 2).blurX(0),
                Tween24.wait(1.5),
                Tween24.prop(text2).glow(0xFFFFFF, 1, 32, 32, 6, 2).blurX(128),
                Tween24.tween(text2, 0.1).$x(200).andRemove(),
                Tween24.wait(0.5),

                // Text3 tween
                Tween24.prop(text3).$x(-460).fadeIn().glow(0xFFFFFF, 1, 32, 32, 6, 2).blurX(128),
                Tween24.addChild(this, text3),
                Tween24.tween(text3, 0.1).fadeIn(),
                Tween24.tween(text3, 0.1).$x(0),
                Tween24.prop(text3).glow(0xFFFFFF, 0.5, 12, 12, 2).blurX(0),
                Tween24.wait(1.5),
                Tween24.prop(text3).glow(0xFFFFFF, 1, 32, 32, 6, 2).blurX(128),
                Tween24.tween(text3, 0.1).$x(200).andRemove(),
                Tween24.wait(0.5),

                // Text4 tween
                Tween24.prop(text4).$y(-20).fadeOut().glow(0xFFFFFF, 0.6, 12, 12, 2, 2),
                Tween24.addChild(this, text4),
                Tween24.tween(text4, 0.6).fadeIn(),
                Tween24.wait(0.4),
                Tween24.tween(text4, 0.4).glow(0xFFFFFF, 1, 24, 24, 8),
                Tween24.tween(text4, 0.6).glow(0xFFFFFF, 0.6, 12, 12, 2),

                // Text5 tween
                Tween24.prop(text5).$y(20).alpha(0),
                Tween24.addChild(this, text5),
                Tween24.tween(text5, 1).alpha(0.6),
                Tween24.func(EventTween24.enabled, true, bg)

            ).play();

        }

        private function getTextField(size:Number, text:String):Bitmap
       {
            var tf:TextField = new TextField();
            tf.autoSize = TextFieldAutoSize.LEFT;
            tf.defaultTextFormat = new TextFormat("_sans", size, 0xFFFFFF);;
            tf.text = text;
            
            var capt:BitmapData = new BitmapData(tf.width << 1, tf.height << 1, true, 0);
            capt.draw(tf, new Matrix(2, 0, 0, 2), null, null, null, true);

            var bitmapData:BitmapData = new BitmapData(tf.width, tf.height, true, 0);
            bitmapData.draw(capt, new Matrix(.5, 0, 0, .5), null, null, null, true);


            var bitmap:Bitmap = new Bitmap(bitmapData);
            bitmap.y = 465 - bitmap.height >> 1;
            bitmap.x = (465 - bitmap.width) >> 1;
            bitmap.smoothing = true;
            return bitmap;

        }

    }

}